您的位置:首页 > 其它

Travelling - HDU 3001 状压dp

2014-07-08 16:37 309 查看


Travelling

Time Limit: 6000/3000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 3358 Accepted Submission(s): 1045



Problem Description

After coding so many days,Mr Acmer wants to have a good rest.So travelling is the best choice!He has decided to visit n cities(he insists on seeing all the cities!And he does not mind which city being his start station because superman can bring him to any
city at first but only once.), and of course there are m roads here,following a fee as usual.But Mr Acmer gets bored so easily that he doesn't want to visit a city more than twice!And he is so mean that he wants to minimize the total fee!He is lazy you see.So
he turns to you for help.



Input

There are several test cases,the first line is two intergers n(1<=n<=10) and m,which means he needs to visit n cities and there are m roads he can choose,then m lines follow,each line will include three intergers a,b and c(1<=a,b<=n),means there is a road between
a and b and the cost is of course c.Input to the End Of File.



Output

Output the minimum fee that he should pay,or -1 if he can't find such a route.



Sample Input

2 1
1 2 100
3 2
1 2 40
2 3 50
3 3
1 2 3
1 3 4
2 3 10




Sample Output

100
90
7


题意:一个人去旅行,最开始可以在任意一个地点,每个地点最多经过两次,问你经过所有地点的最少花费是多少。

思路:因为每个点最多经过两个,所以要用3进制的状压dp。dp[S][i]表示起点在i达到S状态的最少花费,然后倒着往前推。

AC代码如下:

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
int dis[20][20],dp[100000][20],n,m,pow[20],dig[100000][20],state[100000],va;
int main()
{ int i,j,k,S,S1,S2,u,v,w,ans,ret;
  pow[0]=1;
  for(i=1;i<=12;i++)
   pow[i]=pow[i-1]*3;
  for(i=1;i<60000;i++)
  { ret=i;
    for(j=1;j<=10;j++)
    { dig[i][j]=ret%3;
      ret/=3;
    }
  }
  while(~scanf("%d%d",&n,&m))
  { memset(dis,-1,sizeof(dis));
    memset(dp,-1,sizeof(dp));
    for(i=1;i<=m;i++)
    { scanf("%d%d%d",&u,&v,&w);
      if(dis[u][v]==-1 || w<dis[u][v])
      {dis[u][v]=w;
       dis[v][u]=w;
      }
    }
    ans=-1;
    for(i=1;i<=n;i++)
     dp[pow[i-1]][i]=0;
    for(S=0;S<pow
;S++)
    { va=1;
      for(i=1;i<=n;i++)
      { if(dig[S][i]==0)
         va=0;
        if(dp[S][i]==-1)
         continue;
        for(j=1;j<=n;j++)
         if(dis[i][j]!=-1 && dig[S][j]<=1  && i!=j)
         { if(dp[S+pow[j-1]][j]==-1)
            dp[S+pow[j-1]][j]=dp[S][i]+dis[i][j];
           else
            dp[S+pow[j-1]][j]=min(dp[S+pow[j-1]][j],dp[S][i]+dis[i][j]);
         }
      }
      if(va)
      for(i=1;i<=n;i++)
       if(dp[S][i]!=-1)
       if(ans==-1)
        ans=dp[S][i];
       else
        ans=min(ans,dp[S][i]);
    }
    printf("%d\n",ans);
  }
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: